/* teXXas Mozilla AddOn
Author: Edward Kuiumdjian
Site: http://www.texxas.de/
*/

const XUL_NS = "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";
  
function texxasPopupShowing() {
  var contextmenu = document.getElementById('menupopup_texxasmenupopup');
  var deck_texxas_arrow = document.getElementById('deck_texxas_arrow');
  contextmenu.showPopup(deck_texxas_arrow,-1,-1,'context','topleft','bottomleft');
}

function createCatgs(mainCatg) {
  var menuID = 'menu_' + mainCatg;
  if(document.getElementById(menuID)) 
    return;
 
  var popupID = 'texxas_' + mainCatg.toLowerCase();
  var popupM = document.getElementById(popupID);
  var menuPopup = document.createElementNS(XUL_NS, "menupopup"); // create a new XUL menupopup
  menuPopup.setAttribute("id", menuID);
  menuPopup.setAttribute("class", "texxasMenu");
  popupM.appendChild(menuPopup);
 
  // add Loading row
  var loadingID = mainCatg + '_loading';
  var loading_item;
  if(!document.getElementById(loadingID)) {
    loading_item = document.createElementNS(XUL_NS, "menuitem"); // create a new XUL menuitem
    loading_item.setAttribute("label", "wird geladen...");
    loading_item.setAttribute("id", loadingID);
    loading_item.setAttribute("class", "texxasMenu");
    menuPopup.appendChild(loading_item);
  }

  var catgSrc = 'http://www.texxas.de/apps/ffExtension/categories.php';
  var fileName = 'texxasCatg.tmp';
  var eTime = 259200;  // 259200 - 3 days - the time we keep the cache for categories

  // check for stored temp categories
  var oProps = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties);
  tmpDir = (oProps.get("TmpD", Components.interfaces.nsIFile)).path;
 
  var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
  file.initWithPath(tmpDir + fileName);

  var data = '';
  var currentDate = new Date();
  var nowTime = currentDate.getTime();

  if (file.exists() && (nowTime < (file.lastModifiedTime + eTime))) {

    var fstream = Components.classes["@mozilla.org/network/file-input-stream;1"].createInstance(Components.interfaces.nsIFileInputStream);
    var cstream = Components.classes["@mozilla.org/intl/converter-input-stream;1"].createInstance(Components.interfaces.nsIConverterInputStream);
    fstream.init(file, -1, 0, 0);
    cstream.init(fstream, "ISO-8859-1", 0, 0); // you can use another encoding here if you wish

    let (str = {}) {
      cstream.readString(-1, str); // read the whole file and put it in str.value
      data = str.value;
    }
    cstream.close(); // this closes fstream
  }  else {
    // get the content online
    var ioService=Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
    var scriptableStream=Components.classes["@mozilla.org/scriptableinputstream;1"].getService(Components.interfaces.nsIScriptableInputStream);

    var channel=ioService.newChannel(catgSrc,null,null);
    var input=channel.open();
    scriptableStream.init(input);
    data = scriptableStream.read(input.available());
    scriptableStream.close();
    input.close();

    // save the categories in temp file
    var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
    foStream.init(file, 0x02 | 0x08 | 0x20, 0664, 0); // write, create, truncate
  
    var converter = Components.classes["@mozilla.org/intl/converter-output-stream;1"].createInstance(Components.interfaces.nsIConverterOutputStream);
    converter.init(foStream, "ISO-8859-1", 0, 0);
    converter.writeString(data);
    converter.close(); // this closes foStream
  } // end else

  var titleMenu = document.createElementNS(XUL_NS, "menuitem"); // create a new XUL menuitem
  titleMenu.setAttribute("label", "Kategorien:");
  titleMenu.setAttribute("class", "texxasMenu");
  menuPopup.appendChild(titleMenu);
  var menuSep = document.createElementNS(XUL_NS, "menuseparator"); // create a new XUL menuseparator
  menuSep.setAttribute("class", "texxasMenu");
  menuPopup.appendChild(menuSep);

  // parse the xml 
  var parser = new DOMParser();
  var xmlDoc=parser.parseFromString(data,"text/xml");
  var catgs = xmlDoc.getElementsByTagName("CATEGORY");
  for (var z=0; z<catgs.length; z++) {
    catgName = catgs[z].childNodes[0].nodeValue;
    menuM = document.createElementNS(XUL_NS, "menu"); // create a new XUL menu
    menuM.setAttribute("label", catgName);
    menuM.setAttribute("class", "texxasMenu");
    //catgNameUml = catgName.replace(/\u00D6/g, 'Oe');
    catgNameUml = changeUmlauts(catgName);
    catgNameUml = catgNameUml.replace(/[^a-zA-Z0-9]/g, '');
    if(mainCatg == 'Heute') mouseFunc = "createMenuItem('" + catgNameUml + "', '');";
    else mouseFunc = "createMenuItem('" + catgNameUml + "', '" + mainCatg + "');";
    menuM.setAttribute("onmouseover", mouseFunc);
    loopID = 'menu_' + (catgNameUml.toLowerCase()).replace(/\s+/g,'') + mainCatg;
    menuM.setAttribute("id", loopID);
    menuPopup.appendChild(menuM);
  }

  // Meine Senderliste
  var meineID = 'meineliste' + mainCatg;
  meineMenu = document.createElementNS(XUL_NS, "menu"); 
  meineMenu.setAttribute("label", "Meine Senderliste");
  meineMenu.setAttribute("class", "texxasMenu");
  mouseFunc = "createMeineListe('" + mainCatg + "');";
  meineMenu.setAttribute("onmouseover", mouseFunc);
  meineMenuPop = document.createElementNS(XUL_NS, "menupopup"); // create a new XUL menupopup
  var meineID = 'meineliste' + mainCatg;
  meineMenuPop.setAttribute("id", meineID);
  meineMenu.appendChild(meineMenuPop);
  menuPopup.appendChild(meineMenu);

  loading_item.setAttribute("hidden", "true");
}

function createMeineListe(twhen) {
  var meineID = 'meineliste' + twhen;
  var synchroID = 'synchro' + twhen;
  if(document.getElementById(synchroID)) return false;
  var meineMenu = document.getElementById(meineID);
  
  var menuSynchro = document.createElementNS(XUL_NS, "menuitem"); // create a new XUL menu
  menuSynchro.setAttribute("label", "\"Meine Senderliste\" synchronisieren");
  menuSynchro.setAttribute("id", synchroID);
  menuSynchro.setAttribute("oncommand", "synchroMeineListe();");
  meineMenu.appendChild(menuSynchro);
  
  // get the list from profile dir
  var oProps = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties);
  var profileDir = (oProps.get("ProfD", Components.interfaces.nsIFile)).path;
 
  var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
  file.initWithPath(profileDir + 'MeineSenderliste.xml');
  if (file.exists()) {
    var menuSep = document.createElementNS(XUL_NS, "menuseparator"); // create a new XUL menuseparator
    meineMenu.appendChild(menuSep);
    
    var fstream = Components.classes["@mozilla.org/network/file-input-stream;1"].createInstance(Components.interfaces.nsIFileInputStream);
    var cstream = Components.classes["@mozilla.org/intl/converter-input-stream;1"].createInstance(Components.interfaces.nsIConverterInputStream);
    fstream.init(file, -1, 0, 0);
    cstream.init(fstream, "ISO-8859-1", 0, 0); // you can use another encoding here if you wish

    let (str = {}) {
      cstream.readString(-1, str); // read the whole file and put it in str.value
      data = str.value;
    }
    cstream.close(); // close fstream

    // get the content online
    var cwhen = 'NOW';
    if(twhen != 'Jetzt')
      cwhen = '2015';
    var currentTime = new Date();  
    var meineliste_url = 'http://www.texxas.de/apps/ffExtension/list.php?' + currentTime.getTime() + '&when=' + cwhen + '&channels=';

    // create the request list
    var parser = new DOMParser();
    var xmlDoc=parser.parseFromString(data,"text/xml");
    var channels = xmlDoc.getElementsByTagName("CHANNEL");
    for (var z=0; z<channels.length; z++) {
      channelName = channels[z].childNodes[0].nodeValue;
      channelID = channels[z].getAttribute("ID");
      if(z>0)
        meineliste_url += '_';
      meineliste_url += channelID;
    }

    // get the content
    var aLabel = 'meineliste' + twhen;
    
    // add Loading row
    var loadingID = aLabel + '_loading';
    var loading_item = document.createElementNS(XUL_NS, "menuitem"); // create a new XUL menuitem
    loading_item.setAttribute("label", "wird geladen...");
    loading_item.setAttribute("id", loadingID);
    meineMenu.appendChild(loading_item);
    
    showListe(aLabel, meineMenu, meineliste_url);
  }
}

function synchroMeineListe() {
  window.open('chrome://texxas/content/meineliste.xul', 'meineliste', 'chrome, centerscreen');
}

function createMenuItem(fLabel, twhen) {
  var aLabel = (fLabel.toLowerCase()).replace(/\s+/g,'') + twhen;
  var xLabel = 'sub_' + aLabel;
  if(document.getElementById(xLabel)) 
    return false;
  
  var parentID = 'menu_';
  if(!twhen) parentID += fLabel.toLowerCase().replace(/\s+/g,'') + 'Heute';
  else parentID += aLabel;
  var parentMenu = document.getElementById(parentID);
  var popup = document.createElementNS(XUL_NS, "menupopup"); // create a new XUL menupopup
  parentMenu.appendChild(popup);
  
  // create category name row
  var tnow = new Date();
  var thour = tnow.getHours();
  if(thour < 10) thour = '0' + thour;
  var tminute      = tnow.getMinutes();
  if(tminute < 10) tminute = '0' + tminute;
  var tmonthnumber = tnow.getMonth() + 1;
  if(tmonthnumber < 10) tmonthnumber = '0' + tmonthnumber;
  var tmonthday    = tnow.getDate();
  if(tmonthday < 10) tmonthday = '0' + tmonthday;
  var tyear        = tnow.getFullYear();
  var t_time = tmonthday + '.' + tmonthnumber + '.' +  tyear + ' ' + thour + ':' + tminute;
  var dWhen = 'Jetzt';
  if(!twhen) 
    dWhen = 'Heute 20:15 Uhr';
  //catgNameUml = fLabel.replace('Oe', "\u00D6"); 
  catgNameUml = changeUmlauts(fLabel);
  var title_row = catgNameUml + ' - ' + dWhen + ' (Abruf: ' + t_time + ' Uhr):';
  var category_item = document.createElementNS(XUL_NS, "menuitem"); // create a new XUL menuitem
  category_item.setAttribute("label", title_row);
  category_item.setAttribute("id", xLabel);
  category_item.setAttribute("class", "texxasMenu");
  popup.appendChild(category_item);
  var menu_separator = document.createElementNS(XUL_NS, "menuseparator"); // create a new XUL menuseparator
  menu_separator.setAttribute("class", "texxasMenu");
  popup.appendChild(menu_separator);
  
  // add Loading row
  var loadingID = aLabel + '_loading';
  var loading_item = document.createElementNS(XUL_NS, "menuitem"); // create a new XUL menuitem
  loading_item.setAttribute("label", "wird geladen...");
  loading_item.setAttribute("id", loadingID);
  loading_item.setAttribute("class", "texxasMenu");
  popup.appendChild(loading_item);
  
  
  var feedUrl = 'http://www.texxas.de/tv/' + aLabel + 'Gadget.xml';
  showListe(aLabel, popup, feedUrl);
}

function showListe(aLabel, aPopup, dataURL) {
  var loadingID = aLabel + '_loading';
  var loading_item = document.getElementById(loadingID);
  var httpRequest = new XMLHttpRequest();
  if (httpRequest.readyState == 4 || httpRequest.readyState == 0) {
    httpRequest.open("GET", dataURL, true);
    httpRequest.onreadystatechange = function () {
      if (httpRequest.readyState == 4) {
        if (httpRequest.status == 200) {
          var data = httpRequest.responseText;
          try {
            var parser= new DOMParser();
            var xmlDoc = parser.parseFromString(data,"text/xml");
            var elements = xmlDoc.getElementsByTagName("item");
            var itemID;
            for (var z=0; z<elements.length; z++) {
              itemID = aLabel + (z+1).toString();
              zLogoSrc = '';
              
              if(elements[z].getElementsByTagName("enclosure")[0]) {
                zLogoSrc = elements[z].getElementsByTagName("enclosure")[0].getAttribute("url");
              }
              
              if(elements[z].getElementsByTagName("comment")[0]) {
                zTime = elements[z].getElementsByTagName("comment")[0].childNodes[0].nodeValue;
              }
              zBroadcast = elements[z].getElementsByTagName("dc:subject")[0].childNodes[0].nodeValue;
              zTitle = elements[z].getElementsByTagName("title")[0].childNodes[0].nodeValue;
              if(zBroadcast == 'Amazon' || zBroadcast == 'eBay') {
                zTime = 'Anzeige';
                zTitle = zTitle.substr(0, 60);  
              } else {
              	zTitle = zTitle.substr(0, 35);  
              }
              
              
              zLink = elements[z].getElementsByTagName("link")[0].childNodes[0].nodeValue;
              menu_item = document.createElementNS(XUL_NS, "menuitem"); // create a new XUL menuitem
              labelValue = zTime + '   ' + zBroadcast + ' - ' + zTitle;
              menu_item.setAttribute("id", itemID);
              menu_item.setAttribute("class", "texxasMenu");
              if(zLink) {
                descLink = "openUILinkIn('" + zLink + "','tab');";
                menu_item.setAttribute("onclick", descLink);
              }
 
              if(zLogoSrc) {
                hboximg = document.createElement("hbox");
                hboximg.setAttribute("style", "width:50px; -moz-box-pack:center;");
                zImg = document.createElementNS(XUL_NS, "image");
                zImg.setAttribute("src", zLogoSrc);
                hboximg.appendChild(zImg);
                menu_item.appendChild(hboximg);
              } 
              zLabel = document.createElementNS(XUL_NS, "label");
              zLabel.setAttribute("value", labelValue);
              menu_item.appendChild(zLabel);
                                        
              aPopup.appendChild(menu_item);
            }
            loading_item.setAttribute("hidden", "true");
          }
          catch(e) {
            alert(e.message);
            return;
          }
        }
      }    
    }
    httpRequest.send(null);
  }
}


function changeUmlauts(str) {
  var returnStr = str.replace(/\u00C4/g, 'Ae');
  returnStr = returnStr.replace(/\u00E4/g, 'ae');
  returnStr = returnStr.replace(/\u00D6/g, 'Oe');
  returnStr = returnStr.replace(/\u00F6/g, 'oe');
  returnStr = returnStr.replace(/\u00DC/g, 'Ue');
  returnStr = returnStr.replace(/\u00FC/g, 'ue');
  returnStr = returnStr.replace(/\u00DF/g, 'ss');

  return returnStr;
}